#include "fract.h"

static int commom_divisor(int a,int b);	//Լ
static int common_multiple(int a,int b);//С
static void reduce(int *num1,int *num2);	//Լ


void Plus(Fract *num1,Fract *num2)
{
	int deno;//ĸ
	
	if(num1->numer==0)	//ų0ֵ
	{
		*num1=*num2;
		return;
	}
	else if(num2->numer==0) return;

	deno=common_multiple(num1->deno,num2->deno);
	num1->numer=deno/num1->deno*num1->numer+deno/num2->deno*num2->numer;
	num1->deno=deno;

}

void Minus(Fract *num1,Fract *num2)
{
	num2->numer=-num2->numer;
	Plus(num1,num2);
}

void Multiply(Fract *num1,Fract *num2)
{
	if(num1->numer==0)return;
	else if(num2->numer==0)
	{
		num1->numer=0;
		return;
	}

	reduce(&num1->deno,&num2->numer);
	reduce(&num1->numer,&num2->deno);

	num1->numer*=num2->numer;
	num1->deno*=num2->deno;

}

void Divide(Fract *num1,Fract *num2)
{
	int temp;
	if(num2->numer==0)
	{
		printf("Ϊ0\n");
		exit(0);
	}
	temp=num2->numer;
	num2->numer=num2->deno;
	num2->deno=temp;
	Multiply(num1,num2);
}


static void reduce(int *num1,int *num2)	//Լֲԭ
{
	int temp,i;
	
	/*iΪ0ʾΪiΪ1ʾnum1Ϊ2ʾnum2Ϊ3ʾΪ*/
	if(*num1<0)
	{
		*num1=-*num1;
		if(*num2<0)
		{
			*num2=-*num2;
			i=3;
		}
		else i=2;
	}
	else
		if(*num2<0)
		{
			*num2=-*num2;
			i=1;
		}
		else i=0;

	temp=commom_divisor(*num1,*num2);
	*num1/=temp;
	*num2/=temp;

	switch(i)
	{
		case 0:break;
		case 1:*num2=-*num2;break;
		case 2:*num1=-*num1;break;
		case 3:*num1=-*num1;*num2=-*num2;break;
	}
}


static int commom_divisor(int a,int b)
{
 	int temp,r;
 	
	if(a<b)
	{
		temp=a;
		a=b;
		b=temp;
	}
	
	while((r=a%b))
	{
		a=b;
		b=r;
 	}
 	
	return b;
}

static int common_multiple(int a,int b)
{
	return a*b/commom_divisor(a,b);
}