#include "list.h"
   
   
static void FreeNode(Node *node);


//indexΪţڸŲ룬ݺƣ
//Χ0list->n
//dataΪmallocָ
void AddNode(List *list,void *data,int index)
{
    Node *p,*node;
	
    if(index<0 || index>list->n)//ֹԽ
        return;
	
	node=(Node *)malloc(sizeof(Node));//data
	node->data=data;

	p=GetNode(list,index-1);
	node->next=p->next;
	p->next=node;
	if(index==list->n)	//βend
		list->end=node;
	list->n++;
}
   
//ɾָŽڵ
void DeleteNode(List *list,int index)
{
    Node *p,*q;
	
    if(index<0 || index>=list->n)
        return;
	

	q=GetNode(list,index-1);
	p=q->next;
	q->next=p->next;
	if(p->data)
		free(p->data);
    free(p);

	if(index==list->n-1)	//ɾβend
		list->end=q;
    list->n--;
}
   
   
//ָŵĽڵ,-1Ϊͷڵ
//ɹNULL
Node *GetNode(List *list,int index)
{
    int i;
    Node *n;
    if(index<-1 || index>=list->n)//ֹԽ
        return NULL;
	if(index==list->n-1)		//β
		return list->end;
    for(i=-1,n=list->head;i<index;i++,n=n->next)
        ;
    return n;
}

void *GetData(List *list,int index)
{
	return GetNode(list,index)->data;
}

//ɹΪNULL
List *CreateList(void)
{
    List *list=(List *)malloc(sizeof(List));
    if(list==NULL)return NULL;
   
    list->n=0;
    list->head=(Node *)malloc(sizeof(Node));
	list->head->next=NULL;	//յͷڵ
	list->head->data=NULL;
	list->end=list->head;
    return list;
}
   
void DestroyList(List *list)
{
    if(list->n!=0)
        FreeNode(list->head);
    free(list);
}
   
//ݹͷŵ
static void FreeNode(Node *node)
{
    if(node->next)
        FreeNode(node->next);
	if(node->data)
		free(node->data);
    free(node);
}